// ~`TṽVmOvOB
// ςƁAςB

/*----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
//#include <time.h>
//#include <malloc.h>

/*----------------------------------------------------------------------*/
#ifndef M_PI
#define M_PI				3.1415926535897932385
#endif
#define INTEL

/*----------------------------------------------------------------------*/

// output file name
char	fn[15];

// projection
short	N, NST;

// radius and center of sample
double	r0, r1, r2;

/*----------------------------------------------------------------------*/

static int StoreProjection(ln)
long		ln;
{
	int			i, j, k, jx;
	double		I0, t, mu, z;
	double		L1, L2, delta;

	double		*po, *pp;
	double		p_sum,p_ave;
	FILE		*fi;

//open output files
	sprintf(fn,"s%04d.sin", ln);
	if((fi = fopen(fn,"wb")) == NULL){ 
		printf("can not open %s for input\n", fn);
		return(-10);
	}

// p ̏
	po = (double *)malloc(N * sizeof(double));
	pp = (double *)malloc(N * sizeof(double));
	
	/*I0=10000.; ˌh炬NƂɎg\*/
	mu=1.0;			/* zW cm^{-1}*/
	delta=0.0001;	/* pixel size = 1um */
	z=0;

	for(j=0;j<NST;++j){
		t=0;
/* version 003
		if((j>100)&&(j<104)){
			z=-j+100;
		}
		if((j>103)&&(j<107)){
			z=j-106;
		}
*/
/* version 004
		if((j>100)&&(j<104)){
			z=-j+100;
		}
		if((j>103)){
			z=3;
		}
*/
		for(k=0;k<N;++k){
			L1=0.;
			L2=0.;
			if((k>(r0-r2))&&(k<(r0+r2))){
				L1=2.*sqrt(r2*r2-(k-r0)*(k-r0));
			}
			if((k>(r0-r1+z))&&(k<(r0+r1-z))){
				L2=2.*sqrt(r1*r1-(k-r0)*(k-r0));
			}
			t=L1-L2;
			*(pp+k)=mu*t*delta;
			*(po+k)=mu*t*delta;

		}
		for(k=10;k<N;++k){
			*(po+k)=*(pp+k);
			
/* version 002
		if((j>100)&&(j<104)){
			for(k=10;k<N;++k){
				*(po+k)=*(pp+k-j+100);
			}
		}
		if((j>103)&&(j<107)){
			for(k=10;k<N;++k){
				*(po+k)=*(pp+k+j-106);
			}
		}
*/
		}
		if(i=fwrite(po,sizeof(double),N,fi)>N*sizeof(double)){
			fprintf(stderr, " Error writing data to %s at %d\n", fn, i);
			fclose(fi);
			return(i+1);
		}
	} // end of j loop
	fclose(fi);
	free(po);
	free(pp);
	return (0);
}


/*----------------------------------------------------------------------*/

int main(argc,argv)
int		argc;
char	**argv;
{
	int			i;
	FILE		*fo;
	long		s_layer;

	if(argc!=2){
		printf("%s layer (0-2000)\n", argv[0]);
		return (-1);
	}

	s_layer=atoi(argv[1]);	/* č\郌C[ԍ */
	N=2048;					/* f̉ */
	NST=1800;				/* e */
	r0=N/2;					/* 蔫̒S */
	r2=0.8*N/2;				/* 蔫̊Oa */
	r1=abs(r2-s_layer)%(int)r2;	/* 蔫̓a r2𒴂Ȃ悤*/

	if((i=StoreProjection(s_layer)) !=0){
		printf("something wrong in StoreProjection (%d)\n",i);
		exit(1);
	}

//open output files
	if((fo=fopen("sino.tmp","w"))==NULL){ 
		printf("can not open %s for input\n", fn);
		exit(1);
	}
	fprintf(fo, "%d\n", N);
	fprintf(fo, "%d\n", NST);
	fprintf(fo, "%d\n", s_layer);
	fprintf(fo, "%f\n", (float)r0);
	fprintf(fo, "1.0\n"); /* Ƃ肠lĂ邾 */
	fprintf(fo, "1.0\n"); /* Ƃ肠lĂ邾 */
	fclose(fo);

	return 0;
}
